@echo off

SET DefaultSkyrimInstall=%ProgramFiles(x86)%\Steam\SteamApps\common\Skyrim
SET DefaultEnderalInstall=%ProgramFiles(x86)%\Steam\SteamApps\common\Enderal

SET DefaultSkyrimMyGames=%USERPROFILE%\Documents\My Games\Skyrim
SET DefaultEnderalMyGames=%USERPROFILE%\Documents\My Games\Enderal

SET BackupSuffix=.SkyrimBackup

call:PromptForSkyrim "Skyrim Installation" "SkyrimInstall" "%DefaultSkyrimInstall%"
call:PromptForEnderal "Enderal Installation" "EnderalInstall" "%DefaultEnderalInstall%"

call:PromptForSkyrim "Skyrim My Games" "SkyrimMyGames" "%DefaultSkyrimMyGames%"
call:PromptForEnderal "Enderal My Games" "EnderalMyGames" "%DefaultEnderalMyGames%"

echo.
echo.

REM Backup Skyrim

echo Backing up existing files...

call:Backup "%SkyrimInstall%"
call:Backup "%SkyrimMyGames%"
call:Backup "%EnderalMyGames%\Skyrim.ini"
call:Backup "%EnderalMyGames%\SkyrimPrefs.ini"

echo.
echo.

REM Make Links

echo Creating links...

call:LinkDir "%SkyrimInstall%" "%EnderalInstall%"
call:LinkDir "%SkyrimMyGames%" "%EnderalMyGames%" 

call:LinkFile "%SkyrimMyGames%\Skyrim.ini" "%EnderalMyGames%\Enderal.ini"
call:LinkFile "%SkyrimMyGames%\SkyrimPrefs.ini" "%EnderalMyGames%\EnderalPrefs.ini"

echo.
echo.

REM Finished

echo Successfully created links
echo Now, install the Creation Kit
echo.

pause

GOTO:EOF

REM Usage: call:PromptForEnderal "Folder Name" "ResultVariableName" "Default Value"
:PromptForEnderal
    call:PromptFor "%~1" "Enter the path to your %~1" "%~2" "%~3"
GOTO:EOF

REM Usage: call:PromptForSkyrim "Folder Name" "ResultVariableName" "Default Value"
:PromptForSkyrim
    call:PromptFor "%~1" "Enter the path to your %~1, or to where it would be if you don't have Skyrim installed" "%~2" "%~3"
GOTO:EOF

REM Usage: call:PromptFor "Folder Name" "Message" "ResultVariableName" "Default Value"
:PromptFor
    echo.
    echo %~2
    echo Leave blank for the default, which is "%~4"

    set _PromptResult=
    set /P _PromptResult="%~1: "

    IF NOT DEFINED _PromptResult SET _PromptResult=%~4
    SET "%~3=%_PromptResult%"
GOTO:EOF

:Backup
    IF NOT EXIST "%~1" GOTO:EOF
    IF EXIST "%~1%BackupSuffix%" ( echo Backup folder/file "%~1%BackupSuffix%" already exists. && echo Did you run this script twice? && pause && exit 1 )

    MOVE "%~1" "%~1%BackupSuffix%" >nul || (echo Unable to backup "%~1" to "%~1%BackupSuffix%" && pause && exit 1)
    echo Backed up "%~1" to "%~1%BackupSuffix%"
GOTO:EOF

:LinkDir
    mklink /D "%~1" "%~2" >nul || (echo Unable to link "%~1" to "%~2" && pause && exit 1)
    echo Linked "%~1" to "%~2"
GOTO:EOF

:LinkFile
    mklink "%~1" "%~2" >nul || (echo Unable to link "%~1" to "%~2" && pause && exit 1)
    echo Linked "%~1" to "%~2"
GOTO:EOF

