@echo off

SET DefaultSkyrimInstall=%ProgramFiles(x86)%\Steam\SteamApps\common\Skyrim
SET DefaultEnderalInstall=%ProgramFiles(x86)%\Steam\SteamApps\common\Enderal

SET DefaultSkyrimMyGames=%USERPROFILE%\Documents\My Games\Skyrim
SET DefaultEnderalMyGames=%USERPROFILE%\Documents\My Games\Enderal

SET BackupSuffix=.SkyrimBackup

call:PromptForSkyrim "Skyrim Installation" "SkyrimInstall" "%DefaultSkyrimInstall%"
call:PromptForEnderal "Enderal Installation" "EnderalInstall" "%DefaultEnderalInstall%"

call:PromptForSkyrim "Skyrim My Games" "SkyrimMyGames" "%DefaultSkyrimMyGames%"
call:PromptForEnderal "Enderal My Games" "EnderalMyGames" "%DefaultEnderalMyGames%"

echo.
echo.

call:UnlinkFile "%EnderalMyGames%\Skyrim.ini"
call:UnlinkFile "%EnderalMyGames%\SkyrimPrefs.ini"

call:UnlinkDir "%SkyrimInstall%"
call:UnlinkDir "%SkyrimMyGames%"

call:RestoreBackup "%EnderalMyGames%\Skyrim.ini"
call:RestoreBackup "%EnderalMyGames%\SkyrimPrefs.ini"
call:RestoreBackup "%SkyrimInstall%"
call:RestoreBackup "%SkyrimMyGames%"

echo.
echo Successfully removed links
echo.
pause

GOTO:EOF

REM Usage: call:PromptForEnderal "Folder Name" "ResultVariableName" "Default Value"
:PromptForEnderal
    call:PromptFor "%~1" "Enter the path to your %~1" "%~2" "%~3"
GOTO:EOF

REM Usage: call:PromptForSkyrim "Folder Name" "ResultVariableName" "Default Value"
:PromptForSkyrim
    call:PromptFor "%~1" "Enter the path to your %~1, or to where it would be if you don't have Skyrim installed" "%~2" "%~3"
GOTO:EOF

REM Usage: call:PromptFor "Folder Name" "Message" "ResultVariableName" "Default Value"
:PromptFor
    echo.
    echo %~2
    echo Leave blank for the default, which is "%~4"

    set _PromptResult=
    set /P _PromptResult="%~1: "

    IF NOT DEFINED _PromptResult SET _PromptResult=%~4
    SET "%~3=%_PromptResult%"
GOTO:EOF

:UnlinkDir
    rmdir "%~1" >nul || (echo Unable to delete link "%~1" && pause && exit 1)
    echo Unlinked "%~1"
GOTO:EOF

:UnlinkFile
    del "%~1" >nul || (echo Unable to delete link "%~1" && pause && exit 1)
    echo Unlinked "%~1"
GOTO:EOF

:RestoreBackup
    IF NOT EXIST "%~1%BackupSuffix%" GOTO:EOF

    MOVE "%~1%BackupSuffix%" "%~1" >nul || (echo Unable to restore "%~1" from backup && pause && exit 1)
    echo Restored "%~1" from backup
GOTO:EOF